#ifndef CAMERA_H
#define CAMERA_H

//    This file is part of JustMotion.

//    JustMotion is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustMotion is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"
#include "event_loop.h"
#include "detect_loop.h"
#include "record_loop.h"
#include "proc_control.h"

class Camera : public QObject
{
    Q_OBJECT

private:

    QFileSystemWatcher *fsW;
    EventLoop          *evtLoop;
    DetectLoop         *detLoop;
    RecordLoop         *recLoop;
    QThread            *thr1;
    QThread            *thr2;
    QThread            *thr3;
    QTimer             *statTimer;
    QString             statPath;
    shared_t            shared;
    uint                objCount;
    bool                delOnZero;

private slots:

    void confChanged(const QString &path);
    void objMinusOne();
    void updateStat();
    void prepForDel();

public:

    explicit Camera(const QString &confFile, const QString &statDir, ProcControl *proc, QCoreApplication *parent);

    int     start(const QString &conf);
    QString statusLine();

signals:

    void stop();
};

#endif // CAMERA_H
