#ifndef PROC_CONTROL_H
#define PROC_CONTROL_H

//    This file is part of JustMotion.

//    JustMotion is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustMotion is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"

class ProcControl : public QObject
{
    Q_OBJECT

private:

    QFileSystemWatcher *fsMon;
    QString             file;
    QString             statPath;
    bool                closeOnZero;
    uint                objCount;

private slots:

    void procFileUpdated(const QString &path);
    void closeApp();

public:

    explicit ProcControl(const QString &procFile, const QString &statDir, QCoreApplication *parent);

    void objPlusOne();
    bool init();

public slots:

    void objMinusOne();

signals:

    void prepForClose();
};

#endif // PROC_CONTROL_H
